import scala.io.Source
import Ceta._

object Main {
  def main(args : Array[String]) {
    if (args.length == 1) start(Source.fromFile(args(0)).toList)
    else error("usage: ceta problemFile.xml(in cpf-format)     (CeTA version 1.17)")
  }

  def start(input : List[Char]) = certifyProof(input) match {
    case Certified(prf) => print("CERTIFIED " + prf.mkString + "\n")
    case Unsupported(msg) => error("UNSUPPORTED\n" + msg.mkString + "\n")
    case Error(msg) => error("REJECTED\n" + msg.mkString + "\n")
  }
}
